/*  IsoView2 - Visualization tool for CactusCode
    Copyright (C) 2004 John Shalf 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
#include "DataType.hh"

bool DataType::byteswap(void *buf, ::Int64 nelements,int elementsize)
{
#ifdef WORDS_BIGENDIAN
	  // we're a bigendian machine - no byteswapping required.
	return false;

#else
	  // we're a littlendian machine - do byteswapping.

char *buffer = static_cast<char*>(buf); // treat as a character buffer 
	if(elementsize<=1) return false; 

	for(::Int64 i=0;i<nelements;i++,buffer+=elementsize)
	{
		  // do the swap thing on each element 
		for(int s=0,d=elementsize-1;s<d;s++,d--)
		{
		char	c=buffer[s]; 
			buffer[s]=buffer[d]; 
			buffer[d]=c;
		}
	} 
	return true;
#endif
}
