// generated by Fast Light User Interface Designer (fluid) version 1.0105

#include "IsoViewUI.h"
#include <stdio.h>

inline void IsoViewUI::cb_Host_i(Fl_Input*, void*) {
  printf("Hostname is now [%s]\n",Host->value());
}
void IsoViewUI::cb_Host(Fl_Input* o, void* v) {
  ((IsoViewUI*)(o->parent()->parent()->user_data()))->cb_Host_i(o,v);
}

inline void IsoViewUI::cb_DataPort_i(Fl_Input*, void*) {
  printf("DataPort is now %s\n",DataPort->value());
}
void IsoViewUI::cb_DataPort(Fl_Input* o, void* v) {
  ((IsoViewUI*)(o->parent()->parent()->user_data()))->cb_DataPort_i(o,v);
}

inline void IsoViewUI::cb_ControlPort_i(Fl_Input*, void*) {
  printf("ControlPort is now %s\n",ControlPort->value());
}
void IsoViewUI::cb_ControlPort(Fl_Input* o, void* v) {
  ((IsoViewUI*)(o->parent()->parent()->user_data()))->cb_ControlPort_i(o,v);
}

inline void IsoViewUI::cb_QuitButton_i(Fl_Return_Button*, void*) {
  exit(0);
}
void IsoViewUI::cb_QuitButton(Fl_Return_Button* o, void* v) {
  ((IsoViewUI*)(o->parent()->parent()->user_data()))->cb_QuitButton_i(o,v);
}

inline void IsoViewUI::cb_RetryButton_i(Fl_Button*, IsoViewUI*) {
  printf("Attempt to re-establish link to remote Cactus job\n");
printf("\tHost=[%s]\tDataPort=%s\tControlPort=%s\n",Host->value(),DataPort->value(),ControlPort->value());
this->net.TryConnection(Host->value(),atoi(ControlPort->value()),atoi(DataPort->value()));
checkNet(this);
}
void IsoViewUI::cb_RetryButton(Fl_Button* o, IsoViewUI* v) {
  ((IsoViewUI*)(o->parent()->parent()->user_data()))->cb_RetryButton_i(o,v);
}

void IsoViewUI::static_colorCB(Fl_Slider *slider,IsoViewUI *gui) {
  gui->glview->setColor(gui->r_slider->value(),
		gui->g_slider->value(),
		gui->b_slider->value(),
		gui->a_slider->value());
}

IsoViewUI::IsoViewUI(NetworkServices &ns):net(ns) {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = mainwin = new Fl_Double_Window(765, 440, "IsoView2");
    w = o;
    o->color((Fl_Color)33);
    o->user_data((void*)(this));
    { Fl_Group* o = new Fl_Group(485, 285, 260, 140);
      o->box(FL_SHADOW_BOX);
      o->color((Fl_Color)174);
      { Fl_Input* o = Host = new Fl_Input(580, 290, 140, 25, "Host:");
        o->callback((Fl_Callback*)cb_Host);
        o->when(FL_WHEN_ENTER_KEY);
        Host->value("<enter host name>");
      }
      { Fl_Input* o = DataPort = new Fl_Input(580, 320, 140, 25, "DataPort:");
        o->callback((Fl_Callback*)cb_DataPort);
        o->when(FL_WHEN_ENTER_KEY);
        DataPort->value("5557");
      }
      { Fl_Input* o = ControlPort = new Fl_Input(580, 350, 140, 25, "ControlPort:");
        o->callback((Fl_Callback*)cb_ControlPort);
        o->when(FL_WHEN_ENTER_KEY);
        ControlPort->value("5558");
      }
      { Fl_Return_Button* o = QuitButton = new Fl_Return_Button(620, 385, 100, 25, "Quit");
        o->callback((Fl_Callback*)cb_QuitButton);
      }
      { Fl_Button* o = RetryButton = new Fl_Button(510, 385, 90, 25, "Retry");
        o->callback((Fl_Callback*)cb_RetryButton, (void*)(this));
      }
      o->end();
    }
    { Fl_Group* o = new Fl_Group(485, 5, 115, 270);
      o->box(FL_SHADOW_BOX);
      o->color((Fl_Color)174);
      { Fl_Value_Slider* o = IsoVal = new Fl_Value_Slider(490, 10, 30, 260, "IsoVal");
        o->type(4);
        o->minimum(1);
        o->maximum(0);
        o->callback((Fl_Callback*)IsoChangeCB, (void*)(this));
        o->align(FL_ALIGN_RIGHT);
        o->when(FL_WHEN_RELEASE);
      }
      { Fl_Value_Output* o = max_label = new Fl_Value_Output(525, 240, 70, 25, "Max");
        o->tooltip("Max Range");
        o->align(FL_ALIGN_TOP_LEFT);
        max_label->value(1);
      }
      { Fl_Value_Output* o = min_label = new Fl_Value_Output(525, 10, 70, 25, "Min");
        o->tooltip("Min Range");
        o->align(FL_ALIGN_BOTTOM_LEFT);
        min_label->value(-1);
      }
      { Fl_Value_Input* o = iso_input = new Fl_Value_Input(525, 150, 45, 25, "iso_input");
        o->callback((Fl_Callback*)ManIsoChange);
        o->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
        o->when(FL_WHEN_ENTER_KEY);
        o->hide();
      }
      o->end();
    }
    { Fl_Group* o = new Fl_Group(610, 5, 135, 270);
      o->box(FL_SHADOW_BOX);
      o->color((Fl_Color)174);
      { Fl_Slider* o = r_slider = new Fl_Slider(620, 15, 25, 180, "R");
        o->color((Fl_Color)1);
        o->minimum(1);
        o->maximum(0);
        o->value(1);
        o->callback((Fl_Callback*)static_colorCB, (void*)(this));
      }
      { Fl_Slider* o = g_slider = new Fl_Slider(650, 15, 25, 180, "G");
        o->color((Fl_Color)2);
        o->minimum(1);
        o->maximum(0);
        o->value(1);
        o->callback((Fl_Callback*)static_colorCB, (void*)(this));
      }
      { Fl_Slider* o = b_slider = new Fl_Slider(680, 15, 25, 180, "B");
        o->color((Fl_Color)4);
        o->minimum(1);
        o->maximum(0);
        o->value(1);
        o->callback((Fl_Callback*)static_colorCB, (void*)(this));
      }
      { Fl_Slider* o = a_slider = new Fl_Slider(710, 15, 25, 180, "A");
        o->color(FL_BACKGROUND2_COLOR);
        o->minimum(1);
        o->maximum(0);
        o->value(1);
        o->callback((Fl_Callback*)static_colorCB, (void*)(this));
      }
      { Fl_Round_Button* o = r_points = new Fl_Round_Button(615, 210, 25, 25, "Points");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->callback((Fl_Callback*)render_methodCB, (void*)(this));
      }
      { Fl_Round_Button* o = r_lines = new Fl_Round_Button(615, 230, 25, 25, "Lines");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->callback((Fl_Callback*)render_methodCB, (void*)(this));
      }
      { Fl_Round_Button* o = r_polys = new Fl_Round_Button(615, 250, 25, 25, "Polygons");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->callback((Fl_Callback*)render_methodCB, (void*)(this));
        r_polys->setonly();
      }
      o->end();
    }
    { GLView* o = glview = new GLView(20, 5, 455, 420, "GLView");
      o->box(FL_ENGRAVED_BOX);
      o->color((Fl_Color)41);
      o->selection_color(FL_BACKGROUND_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(0);
      o->labelsize(14);
      o->labelcolor(FL_BLACK);
      o->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
      o->when(FL_WHEN_RELEASE);
      o->end();
    }
    o->end();
    o->resizable(o);
  }
}

void IsoViewUI::show() {
  this->mainwin->show();
//Fl::add_idle((Fl_Timeout_Handler)IsoViewUI::checkNet,(void*)this);
Fl::add_timeout(0.01, timecall,(void*)this);
}

void IsoViewUI::setIsoRange(double _min,double _max) {
  this->min_label->value(_min);
this->max_label->value(_max);
this->IsoVal->range(_min,_max);
}

void IsoViewUI::checkNet(IsoViewUI *self) {
  int r;
r=self->net.CheckNet();
switch(r){
case -1:
	printf("\tNetwork not connected\n");
	break;
case 0:
	printf("\tNo new data on the network\n");
	break;
case 1:
	if(self->net.numverts && self->net.verts && self->net.numtris && self->net.tris)
	{
		if (self->net.run==0)
		{
			self->setIsoVal(self->net.value);
			self->net.run=1;
		}
		self->setIsoRange(self->net.range[0],self->net.range[1]);
		self->glview->setSurface(self->net.numverts,self->net.verts,self->net.numtris,self->net.tris,self->net.numnorms,self->net.norms);
		self->net.numverts=0;
		self->net.numtris=0; 
	}
	Fl::repeat_timeout(0.01, timecall, (void*)self);
	break;
default:
	printf("\tI do not understand this return value in IsoViewUI::checkNet()\n");
	break;
}
}

void IsoViewUI::timecall(void* tmp) {
  checkNet((IsoViewUI*)tmp);
}

void IsoViewUI::render_methodCB(Fl_Round_Button *button, IsoViewUI *gui) {
  gui->glview->setRender(gui->r_points->value(), gui->r_lines->value(), gui->r_polys->value());
}

void IsoViewUI::IsoChangeCB(Fl_Value_Slider *slider, IsoViewUI *gui) {
  gui->net.IsoValueChange(gui->IsoVal->value(), (void*)gui);
gui->iso_input->value(gui->IsoVal->value());
}

void IsoViewUI::ManIsoChange(Fl_Value_Input *input, IsoViewUI *gui) {
  //gui->net.IsoValueChange(gui->iso_input->value(), (void*)gui);
fprintf(stderr, "%f\n", input->value());
gui->IsoVal->value(gui->iso_input->value());
}

void IsoViewUI::setIsoVal(float value) {
  this->IsoVal->value(value);
}
